'use strict';

/* eslint-disable no-param-reassign */

module.exports = class BaseExzeoError extends Error {
  constructor(message, errorCode, statusCode) {
    if (typeof message !== 'string') message = 'An error has occured';
    super(message);
    Error.captureStackTrace(this, this.constructor);
    this.name = this.constructor.name;

    if (typeof errorCode !== 'string') errorCode = 'INTERNAL_SERVER_ERROR';
    if (typeof statusCode !== 'number') statusCode = 500;

    this.errorCode = errorCode.replace(/\s+/g, '_').toUpperCase();
    this.statusCode = statusCode;
  }
};
