'use strict';

module.exports = class Rpc extends require('../BaseExzeoError') {
  /**
   *
   * @param {Object} response
   * @param {Object} [options]
   * @param {String} [options.message]
   * @param {String} [options.customErrorCode]
   */
  constructor(response = {}, options = {}) {
    if (typeof response !== 'object') response = {}; // eslint-disable-line no-param-reassign
    if (typeof options !== 'object') options = {}; // eslint-disable-line no-param-reassign
    const { message, customErrorCode } = options;
    super(message || response.message, `RPC_${customErrorCode || 'GENERIC'}`, response.status);

    // an errors array may be emitted if multiple errors occur
    if (response.errors) this.errors = response.errors;
    // record result
    if (response.result) this.result = response.result;
  }
};
